"use strict";

$(document).ready(() => {

    let settings = getSettings();

    $(function () {
            $('#groupTree').jstree(
                {
                    "core": {
                        // so that create works
                        "check_callback": true,
                        error: function (err) {
                            console.log(err);
                        }
                    },
                },
            );
        }
    );

    $('#groupTree').on("changed.jstree", function (e, data) {
        const singleNumRegexp = /\w_(\d+)/;

        const parseClass = function (str) {

            singleNumRegexp.lastIndex = 0;
            let foundMatch = singleNumRegexp.exec(str);
            return foundMatch ? parseInt(foundMatch[1]) : 0;

        };

        let groupID = parseClass(data.selected[0]);

        let getDisciplines = function (groupID, url, onSuccess, onFail, successText, errorText) {
            $.post(g_URLdir + url, {groupID: groupID}).success((disciplines) => {
                Popup.success(successText);
                onSuccess(JSON.parse(JSON.parse(disciplines).response));
            }).fail(jqXHR => {
                onFail();
                const status = parseInt(jqXHR.status);
                let message = errorText;
                try {
                    if (status === 400)
                        message = JSON.parse(jqXHR.responseText).message;
                } catch (error) {
                }
                if (status !== 0)
                    Popup.error(message);
            });
        };

        getDisciplines(groupID, 'handler/discipline/getDisciplinesForGroup',
            function (disciplines) {
                jQuery.each(disciplines, function (i, val) {
                    $("#" + i).append(document.createTextNode(" - " + val));
                    $('#groupTree').jstree().create_node(data.selected, {
                        "id": val.ID,
                        "text": val.SubjectName,
                    }, "last");
                });
            },
            function () {
            }, "дисциплины загрузились", "ошибка");
    })

    // $('#syncInnerDepartments').click(()=>{
    //     $.get(pathToSfeduAPIAdapter + 'subdivisions/inner');
    // });

});
